<template functional>
  <div id="class_list_wrapper">
    <div>
      <el-table :data="props.list" @row-click="listeners['row-click']" class="elTable-label" :empty-text="parent.$t('TEACHER_CLASS.NO_COURSE')">
        <el-table-column
          prop="index"
          label="#"
          width="50"
          align="left"
        >
          <template slot-scope="scope">
            {{ scope.$index + 1 }}
          </template>
        </el-table-column>

        <!-- <el-table-column
          prop="type"
          :label="parent.$t('TEACHER_CLASS.TYPE')"
          width="110"
          align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.type === 4">
              {{ parent.$t('TEACHER_CLASS.PUBLIC') }}
            </span>
            <span v-else>
              {{ parent.$t('TEACHER_CLASS.PRIVATE') }}
            </span>
          </template>
        </el-table-column> -->

        <el-table-column
          prop="name"
          :label="parent.$t('TEACHER_CLASS.COURSE')"
          width="300"
          align="left"
        >
          <template slot-scope="scope">
            [{{scope.row.affiliation_name}}]{{scope.row.name}}
          </template>
        </el-table-column>

        <el-table-column
          prop="description"
          :label="parent.$t('TEACHER_CLASS.COURSE_INTRO')"
          align="left"
        >
          <template slot-scope="scope">
            {{ scope.row.description | truncate(20) }}
          </template>
        </el-table-column>

        <el-table-column
        label="수강 인원"
        align="center"
        width="90%">
          <template slot-scope="scope">
            {{scope.row.users.length}}
          </template>
        </el-table-column>

        <el-table-column
        label="평점"
        align="center"
        width="160">
          <template slot-scope="scope">
            <el-rate :value="scope.row.rate" disabled show-score></el-rate>
          </template>
        </el-table-column>

        <el-table-column
          :label="parent.$t('TEACHER_CLASS.PERIOD')"
          width="250"
          align="center"
        >
          <template slot-scope="scope">
            {{ scope.row.start_time ? new Date(scope.row.start_time).toLocaleDateString('ko-KR') : parent.$t('TEACHER_CLASS.UNDECIDED') }} 
            ~
            {{ scope.row.end_time ? new Date(scope.row.end_time).toLocaleDateString('ko-KR') : parent.$t('TEACHER_CLASS.UNDECIDED') }}
          </template>
        </el-table-column>
        <el-table-column
          label="-"
          width="150"
          align="center"
        >
          <template slot-scope="scope">
            <el-button>{{ parent.$t('TEACHER_CLASS.LECTURE_LIST') }}</el-button>
          </template>
        </el-table-column>

        
        <!--el-table-column
          v-if="!props.isPhone"
          label="-"
          width="90"
          align="left"
        >
          <template slot-scope="scope">
            <router-link :to="`/a/teacher/NNclass/${scope.row.class_id}/edit`">
              <el-button class="edit-btn">{{ parent.$t('LECTURE_LIST.EDIT') }}</el-button>
            </router-link>
          </template>
        </el-table-column-->
        <!--
        <el-table-column
          label="-"
          width="90"
          align="left"
        >
          <template slot-scope="scope">
            <el-button type="danger" @click="listeners['delete'](scope.$index)" class="delete-btn">삭제</el-button>
          </template>
        </el-table-column>
        -->
      </el-table>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ClassList',
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        const allowedTypeList = ['TEACHER', 'STUDENT'];
        if (!allowedTypeList.includes(value)) {
          // eslint-disable-next-line no-console
          console.error(`prop "type" should be one of ${allowedTypeList}`);
          return false;
        }
        return true;
      },
    },
    list: {
      type: Array,
      required: true,
      validator(value) {
        if (!Array.isArray(value)) {
          // eslint-disable-next-line no-console
          console.error('prop "list" should be type Array');
          return false;
        }
        if (value.length === 0) {
          return true;
        }
        const firstElement = value[0];
        const allowedKeyOfClassListItem = ['id']; // TODO: improve this list
        const firstElementKeySet = new Set(Object.keys(firstElement));
        if (firstElementKeySet.size === 0) {
          throw new Error('ClassList empty element received.');
        }
        for (let i = 0; i < allowedKeyOfClassListItem; i += 1) {
          const expectedKey = allowedKeyOfClassListItem[i];
          if (!firstElementKeySet.has(expectedKey)) {
            // eslint-disable-next-line no-console
            console.error(`prop "list" should have \`${expectedKey}\``);
            return false;
          }
        }
        return true;
      },
    },
    isPhone: {
      type: null,
    },
  },
};
</script>

<style lang="scss" scoped>
#class_list_wrapper {
  .elTable-label {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
    text-align: center;
  }
  .elTable-label tr {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .elTable-label td {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #606266;
  }
  .edit-btn{
    
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #1989fa;
    
    background-color: none;
    border-color: none;
  }
}

</style>
